﻿import cyan3d.Vector3D;
import cyan3d.Matrix3D;

class cyan3d.Camera3D
{
	//カメラ上向き三次元ベクトル
	var _up:Vector3D;
	//カメラ注視点三次元ベクトル
	var _lookAt:Vector3D;
	//カメラ位置三次元ベクトル
	var _position:Vector3D;
	
	var _near:Number = 50;
	var _far:Number = 10000;

	public function Camera3D()
	{
		_up = new Vector3D(0, 1, 0);
		_lookAt = new Vector3D(0,0,0);
		_position = new Vector3D(0,0,-500);
	}

	//カメラの向き「注視点－位置」を正規化(長さ1にする計算)
	public function direction():Vector3D
	{
		var dir = new Vector3D();

		dir._x = _lookAt._x - _position._x;
		dir._y = _lookAt._y - _position._y;
		dir._z = _lookAt._z - _position._z;
			
		dir.normalize();
			
		return dir;
	}

	//ビュー行列を計算し、行列値を返す
	public function viewMatrix():Matrix3D
	{
		var zAxis:Vector3D = direction();

		var xAxis:Vector3D = _up.crossProduct(zAxis);
		xAxis.normalize();
		
		var yAxis:Vector3D = zAxis.crossProduct(xAxis);

		var m:Matrix3D = new Matrix3D();

		m._e00 = xAxis._x;
		m._e10 = yAxis._x;
		m._e20 = zAxis._x;
		m._e30 = 0;
		m._e01 = xAxis._y;
		m._e11 = yAxis._y;
		m._e21 = zAxis._y;
		m._e31 = 0;
		m._e02 = xAxis._z;
		m._e12 = yAxis._z;
		m._e22 = zAxis._z;
		m._e32 = 0;
		m._e03 = -_position.dotProduct(xAxis);
		m._e13 = -_position.dotProduct(yAxis);
		m._e23 = -_position.dotProduct(zAxis);
		m._e33 = 1;

		return m;
	}
}
