﻿import cyan3d.Vector2D;
import cyan3d.Vector3D;
import cyan3d.Material;

class cyan3d.Face3D
{
	var _index:Array;
	var _normal:Vector3D;
	var _visible:Boolean;
	var _material;
	var _color;

	public function Face3D(index:Array,material)
	{
		//頂点インデックス配列
		_index = index;
		_material = material;
	}

	public function setNormal(v:Vector3D,v1:Vector3D,v2:Vector3D)
	{
		//法線計算
		var x:Number = v1._x - v._x;
		var y:Number = v1._y - v._y;
		var z:Number = v1._z - v._z;
		var A:Vector3D = new Vector3D(x, y, z);
		x = v2._x - v._x;
		y = v2._y - v._y;
		z = v2._z - v._z;
		var B:Vector3D = new Vector3D(x, y, z);
		_normal = B.crossProduct(A);
	}
	
	//ライトの向きから面の陰影
	public function setShade(material:Material)
	{
		var normal:Vector3D =
			new Vector3D(_normal._x, _normal._y, _normal._z);
		normal.normalize();
		var light:Vector3D = new Vector3D(1,1,1);
		light.normalize();
		var shade:Number = Math.abs(normal.dotProduct(light));
		shade += 1;
		shade /= 2;
	
		//RGB値からカラーに変換
		_color = material._r * shade << 16 |
				 material._g * shade << 8  |
				 material._b * shade;
	}
}
