import cyan3d.*;

class models.Dungeon extends Model3D
{
	public function Dungeon(size:Number,map:Array,mapSize)
    {
		//親クラスのコンストラクタ呼び出し
		super();
		//材質
		_material = new Array();
		addM(0xcc,0xcc,0xff);
		//ワールド座標頂点
		_world = new Array();
		var i = 0;
		for ( var x = 1; x < mapSize-1; x++ )
		{
			for ( var z = 1; z < mapSize-1; z++ )
			{
				if ( map[z * mapSize + x] == 1 )
				{
					Wall(size, x * size, z * size);
					i++;
					Wall2(size,x*size,z*size);
					i++;
					if ( map[(z - 1) * mapSize + x] == 0 )
					{
						Wall3(size,x*size,z*size);
						i++;
					}
					if ( map[(z + 1) * mapSize + x] == 0 )
					{
						Wall4(size,x*size,z*size);
						i++;
					}
					if ( map[z * mapSize + (x+1)] == 0 )
					{
						Wall5(size,x*size,z*size);
						i++;
					}
					if ( map[z * mapSize + (x-1)] == 0 )
					{
						Wall6(size,x*size,z*size);
						i++;
					}
				}
			}
		}
		//3D面
		_face = new Array();
		for ( var j = 0; j < i; j++ )
		{
			addF(new Array(j*4, j*4+1, j*4+2, j*4+3), 0);
		}
		
		init();
    }

	private function Wall(size, x, z)
	{
		addV(     x, 0,      z);
		addV(     x, 0, z+size);
		addV(x+size, 0, z+size);
		addV(x+size, 0,      z);
	}

	private function Wall2(size, x, z)
	{
		addV(x+size, -size,      z);
		addV(x+size, -size, z+size);
		addV(     x, -size, z+size);
		addV(     x, -size,      z);
	}
	
	private function Wall3(size, x, z)
	{
		addV(x+size,     0,    z);
		addV(x+size, -size,    z);
		addV(     x, -size,    z);
		addV(     x,     0,    z);
	}
	
	private function Wall4(size, x, z)
	{
		addV(     x,     0, z+size);
		addV(     x, -size, z+size);
		addV(x+size, -size, z+size);
		addV(x+size,     0, z+size);
	}
	
	private function Wall5(size, x, z)
	{
		addV(x+size,     0,      z);
		addV(x+size,     0, z+size);
		addV(x+size, -size, z+size);
		addV(x+size, -size,      z);
	}

	private function Wall6(size, x, z)
	{
		addV(x, -size,      z);
		addV(x, -size, z+size);
		addV(x,     0, z+size);
		addV(x,     0,      z);
	}
}
